// BonDriver_dyud.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"

//TS̃Oꍇ
//#define DEBUG_TS_DUMP

#define BONDRIVER_DYUD_MAIN
#include "aescpp.h"
#include "crc32calc.h"
#include "BonDriver_dyud.h"

CRC32Calc CrcCalc;

cDY_UD200* cDY_UD200::pThis = NULL;

const BOOL cDY_UD200::OpenTuner(void)
{
	UCHAR szRes[128];
	TCHAR szDbg[128];

	UCHAR szCmdInit[36] = {0x0f, 0xf0, 0xe0, 0x20, 0x00, 0x00, 0x00, 0x00, 0x23, 0x8d, 0xc0, 0xd0, 0x0e, 0xd0, 0x38, 0x75,
							0xe8, 0x38, 0xdf, 0xeb, 0x33, 0x7d, 0x39, 0x52, 0xe3, 0x78, 0xeb, 0xd1, 0xb7, 0x84, 0xef, 0x65,
							0x00, 0x9a, 0x0f, 0x3a};
	UCHAR szCmdInitNF[8] = {0x1f, 0xf0, 0xe3, 0x04, 0x00, 0x00, 0x00, 0x00};
	UCHAR szCmdResetBCASA[9] = {0x1f, 0xf0, 0xf0, 0x05, 0x02, 0x00, 0x42, 0x00, 0x00};
	UCHAR szCmdResetBCASB[9] = {0x1f, 0xf0, 0xf0, 0x05, 0x02, 0x00, 0x41, 0x00, 0x00};
	UCHAR szCmdResetBCASC[19] = {0x1f, 0xf0, 0xf0, 0x0e, 0x02, 0x00, 0x31, 0x00, 0x09, 0x00, 0x00, 0x05, 0x90, 0x30, 0x00, 0x00,
								0x00, 0xa5, 0x00};
	UCHAR szCmdGetBCASId[19] = {0x1f, 0xf0, 0xf0, 0x0e, 0x02, 0x00, 0x31, 0x00, 0x09, 0x00, 0x40, 0x05, 0x90, 0x32, 0x00, 0x00,
								0x00, 0xe7, 0xce};

	if(this->IsTunerOpening())
	{
		OutputDebugDYUD200(_T("OpenTuner() Already opened.\n"));
		return TRUE;
	}
	try
	{
		this->uBCAScycle = 0;

		OutputDebugDYUD200(_T("OpenTuner() Initialize start.\n"));

		//󂢂ĂfoCXĊJ
		if(!this->Initialize_Device())throw (const DWORD)__LINE__;

		//R}hM
		if(!this->SendCommandAndRecvResponse(szCmdInit, 34, szRes, 128))throw (const DWORD)__LINE__;
		if(!this->StopTSStreaming())throw (const DWORD)__LINE__;

		//`lƃ`lԂZbg
		this->dwCurChannel = -1;
		this->dwCurSpace = -1;

		//Vt@[pR}hHG[Ԃ
		if(!this->SendCommandAndRecvResponse(szCmdInitNF, 8, szRes, 2))throw (const DWORD)__LINE__;

		//FirmwareVer擾ă`FbN
		FIRMVERSION fv;fv.ul=0;
		this->GetFirmwareVersion(&fv);

		_stprintf_s(szDbg, _T("DY-UD200 Firmware version: %d.%d.%d-%d\n"), fv.D.major, fv.D.minor1, fv.D.minor2, fv.D.minor3);
		OutputDebugDYUD200(szDbg);
		if(this->enableFirmAlert)
		{
			switch(fv.ul)
			{
			case 0x01000202:
				break;
			case 0x01000502:
				MessageBox(NULL, L"1.0.2Vt@[EFAłB\ñt@[EFAł͏\ɃfobOĂ܂B", L"x", MB_OK|MB_ICONWARNING);
				break;
			default:
				MessageBox(NULL, L"1.0.2Vt@[EFAłB\ñt@[EFAł͓삵܂B", L"x", MB_OK|MB_ICONWARNING);
				break;
			}
		}

		//{̂̃VAio[擾
		char szSerial[16];
		TCHAR tcSerial[16];
		if(!this->GetSerialnumber(szSerial))throw (const DWORD)__LINE__;

		charToTchar(tcSerial, 16, szSerial);
#ifdef DEBUG_LOGGING
		_stprintf_s(szDbg, _T("DY-UD200 Serial: XXXXXXXX\n"), tcSerial);
#else
		_stprintf_s(szDbg, _T("DY-UD200 Serial: %s\n"), tcSerial);
#endif
		OutputDebugDYUD200(szDbg);

		//SegModẽZbg
		if(!this->SetSegMode())throw (const DWORD)__LINE__;

		//B-CASRg[Zbg
		if(!this->SendCommandAndRecvResponse(szCmdResetBCASA, 9, szRes, 128))throw (const DWORD)__LINE__;
		if(!this->SendCommandAndRecvResponse(szCmdResetBCASB, 9, szRes, 128))throw (const DWORD)__LINE__;

		//B-CASJ[hZbgAłɃfXNuɃVXeL[ƏCBCZbg
		if(!this->SendCommandAndRecvResponse(szCmdResetBCASC, 19, szRes, 128))throw (const DWORD)__LINE__;
		this->tsDescrambler.InitializeSystemKey(&szRes[7+16], &szRes[7+48]);

		//B-CASJ[hID̎擾
		if(!this->SendCommandAndRecvResponse(szCmdGetBCASId, 19, szRes, 128))throw (const DWORD)__LINE__;

		long long llBCASid;
		llBCASid = ((long long)szRes[16] << 40) + ((long long)szRes[17] << 32) + ((long long)szRes[18] << 24)
					+ ((long long)szRes[19] << 16) + ((long long)szRes[20] << 8) + (long long)szRes[21];
		llBCASid *= 100000;
		llBCASid += ((long long)szRes[22] << 8) + (long long)szRes[23];
#ifdef DEBUG_LOGGING
		_stprintf_s(szDbg, _T("DY-UD200 B-CAS ID: XXXX-XXXX-XXXX-XXXX-XXXX\n"), (llBCASid/10000000000000000)%10000,
					(llBCASid/1000000000000)%10000, (llBCASid/100000000)%10000, (llBCASid/10000)%10000, llBCASid%10000);
#else
		_stprintf_s(szDbg, _T("DY-UD200 B-CAS ID: %04lld-%04lld-%04lld-%04lld-%04lld\n"), (llBCASid/10000000000000000)%10000,
					(llBCASid/1000000000000)%10000, (llBCASid/100000000)%10000, (llBCASid/10000)%10000, llBCASid%10000);
#endif
		OutputDebugDYUD200(szDbg);

		//TSMARMeXbh̐
		OutputDebugDYUD200(_T("DY-UD200 Create threads...\n"));

		DWORD dwTID;
		this->hRecvTSThread = CreateThread(NULL, 0UL, cDY_UD200::RecvTSThread, this, CREATE_SUSPENDED, &dwTID);
		if(!this->hRecvTSThread) throw (const DWORD)__LINE__;
		if(!SetThreadPriority(this->hRecvTSThread, this->threadPriority)) throw (const DWORD)__LINE__;
		this->hRecvRemoconThread = CreateThread(NULL, 0UL, cDY_UD200::RecvRemoconThread, this, CREATE_SUSPENDED, &dwTID);
		if(!this->hRecvRemoconThread) throw (const DWORD)__LINE__;

		this->bLoopThread = TRUE;
		if(ResumeThread(this->hRecvTSThread) == 0xFFFFFFFFUL)throw (const DWORD)__LINE__;
		if(ResumeThread(this->hRecvRemoconThread) == 0xFFFFFFFFUL)throw (const DWORD)__LINE__;

		OutputDebugDYUD200(_T("OpenTuner() Initialize complete.\n"));

	}catch(const DWORD dwError){
		_stprintf_s(szDbg, _T("Initialize() dwErrorStep: %lu GetLastError: 0x%x\n"), dwError, GetLastError());
		OutputDebugDYUD200(szDbg);

		CloseTuner();
		return FALSE;
	}
#ifdef DEBUG_TS_DUMP
	hTSLogFile  = CreateFile(_T("dump.ts") ,GENERIC_WRITE ,0 ,NULL ,CREATE_ALWAYS ,FILE_ATTRIBUTE_NORMAL ,NULL);
#endif
	return TRUE;
}

void cDY_UD200::CloseTuner(void)
{
	this->bLoopThread = FALSE;

	if(this->hRecvTSThread){
		if(WaitForSingleObject(this->hRecvTSThread, 1000) != WAIT_OBJECT_0){
			TerminateThread(this->hRecvTSThread, 0);
			OutputDebugDYUD200(_T("CloseTuner() Terminated RecvTS thread.\n"));
		}		

		CloseHandle(this->hRecvTSThread);
		this->hRecvTSThread = NULL;
	}

	if(this->hRecvRemoconThread){
		if(WaitForSingleObject(this->hRecvRemoconThread, 1000) != WAIT_OBJECT_0){
			TerminateThread(this->hRecvRemoconThread, 0);
			OutputDebugDYUD200(_T("CloseTuner() Terminated RecvRemocon thread.\n"));
		}		

		CloseHandle(this->hRecvRemoconThread);
		this->hRecvRemoconThread = NULL;
	}

	if(this->usbBackend->IsOpened())
		this->usbBackend->Close();

	OutputDebugDYUD200(_T("CloseTuner() Closed tuner.\n"));

#ifdef DEBUG_TS_DUMP
	CloseHandle(hTSLogFile);
#endif
}


const BOOL cDY_UD200::SetChannel(const BYTE bCh)
{
	////////////////////////////////////////////////////////////////////
	// IBonDriverƂ̌݊ۂ߂Ɏb
	////////////////////////////////////////////////////////////////////

	if(bCh < 13 || bCh > 62)return FALSE;
	else return this->SetChannel(0, bCh - 13);
}

const float cDY_UD200::GetSignalLevel(void)
{
	UCHAR szCmd[8] = {0x1f, 0xf0, 0xd5, 0x04, 0x00, 0x00, 0x00, 0x00};
	TCHAR szDbg[128];
	UCHAR szRes[6];
	BIDWORD ul;

	if(!this->EnableAntLv)
	{
		OutputDebugDYUD200(_T("GetSignalLv() disabled. Fixed to 10.0\n"));
		return 10.0f;
	}

	OutputDebugDYUD200(_T("GetSignalLv() Testing implementation.\n"));

	if(!this->SendCommandAndRecvResponse(szCmd, 8, szRes, 6))
	{
		OutputDebugDYUD200(_T("GetSignalLv() Internal error.\n"));
		return FALSE;
	}

	if(szRes[0])
	{
		OutputDebugDYUD200(_T("GetSignalLv() Tuner returned error.\n"));
		return FALSE;
	}

	ul = *(DWORD*)(szRes+2)&0xffffff00;
	_stprintf_s(szDbg, _T("GetSignalLv() result: 0x%08x(BE) %f\n"), ul.GetInvert(), ul.GetInvert()/65536.0f);
	OutputDebugDYUD200(szDbg);

	if(szRes[2])
		return ul.GetInvert()/65536.0f*20.0f;
	return 0.0f;
}
const DWORD cDY_UD200::WaitTsStream(const DWORD dwTimeOut)
{
	DWORD st = timeGetTime();
	while(!dwTimeOut || timeGetTime() < st+dwTimeOut)
	{
		if(this->GetReadyCount())
		{
			return WAIT_OBJECT_0;
		}
		Sleep(1);
	}
	return WAIT_ABANDONED;
}

const DWORD cDY_UD200::GetReadyCount()
{
	return this->ringBufferRecv->UsedSize()/TS_CHUNK_SIZE;
}

const BOOL cDY_UD200::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	BYTE* pSrc = NULL;

	if(GetTsStream(&pSrc, pdwSize, pdwRemain))
	{
		if(*pdwSize)
		{
			memcpy(pDst, pSrc, *pdwSize);
		}
		return TRUE;
	}
	return FALSE;
}

const BOOL cDY_UD200::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	DWORD dwReady = this->GetReadyCount();

	if(dwReady)
	{
		this->LockTs();

		for(int i=0; i<TS_CHUNK_SIZE; i++)
		{
			CTSPacket* pkt = this->ringBufferRecv->GetData();

			//xorÍ̕
			do{
				//xorÍ͖
				if(!this->xorCryptedFlag)
					break;

				if(pkt->PID() < 0x10 || pkt->PID() == 0x1fff)
					break;//PIDÍΏ۔͈͊O

				if( pkt->PayloadScrambleControl() < 2)
					break;//XNutOĂȂ

				if( !pkt->Priority() )
					break;//DxtOĂȂ

				BYTE* packetptr = pkt->GetPacket();

				//DxtO͋IɗƂ
				packetptr[1] ^= 0x20;

				XORcrypt(this->szTSxorLUT, packetptr+4, packetptr+4, 128);
			}while(0);

			if(this->dwCurSpace == 2)
			{//ZO[h
				this->onesegPatGen.ParsePacket(*pkt);

				//PMT̒OPAT𐶐đ}
				do{
					if(pkt->PID() != 0x1fc8)
						//ZOPMTł͂Ȃ
						break;

					if(i+1 == TS_CHUNK_SIZE)
						//`Nł̍ŏIpPbgȂ̂PAT錄ԂȂ
						break;

					CTSPacket* pat = this->onesegPatGen.GetPAT();

					if(pat == NULL)
						//NITAPMT̉͂IĂȂ
						break;

					BYTE* CurrPtr = this->GetTsStreamBuffer+(TS_PACKET_SIZE*i);
					memcpy(CurrPtr, pat->GetPacket(), TS_PACKET_SIZE);
					i++;
				}while(0);
			}else{
				//B25fR[h
				if(this->enableB25Decode)
					this->tsDescrambler.ParsePacket(*pkt);
			}

			BYTE* CurrPtr = this->GetTsStreamBuffer+(TS_PACKET_SIZE*i);
			memcpy(CurrPtr, pkt->GetPacket(), TS_PACKET_SIZE);
			
		}
		*ppDst = this->GetTsStreamBuffer;
		*pdwSize = TS_PACKET_SIZE*TS_CHUNK_SIZE;
		*pdwRemain = dwReady - 1;

		this->UnlockTs();

#ifdef DEBUG_TS_DUMP
		OutputDebugDYUD200(_T("GetTsStream() return TS packet\n"));
		DWORD dwSize;
		WriteFile(hTSLogFile, this->szGTSBuffer, TS_PACKET_SIZE, &dwSize, NULL);
#endif
		return TRUE;
	}else{
		*pdwSize = 0;
		*pdwRemain = 0;
	}
	return TRUE;
}

void cDY_UD200::Release()
{
	OutputDebugDYUD200(_T("Release()\n"));

	this->LockTs();
	this->CloseTuner();
	if(this->dwLifecounter == 1)
	{
//		delete this;
	}else{
		this->dwLifecounter--;
		this->UnlockTs();
	}
}

void cDY_UD200::PurgeTsStream(void)
{
	if(!this->IsTunerOpening())
		return;

	OutputDebugDYUD200(_T("PurgeTsStream()\n"));

	this->LockTs();

	this->ringBufferRecv->Clear();

	this->UnlockTs();
}

LPCTSTR cDY_UD200::GetTunerName(void)
{
	return _T("DY-UD200");
}

const BOOL cDY_UD200::IsTunerOpening(void)
{
	return this->usbBackend->IsOpened();
}

LPCTSTR cDY_UD200::EnumTuningSpace(const DWORD dwSpace)
{
	switch(dwSpace)
	{
	case 0:	return _T("nfW");
	case 1:	return _T("nfW /w CATVgϊpXX[");
	case 2: return _T("ZO");
	case 3:	if(this->EnableDigiRadio)return _T("fW^WIMł邩Ȃ");
	default:return NULL;
	}
}

LPCTSTR cDY_UD200::EnumChannelName(const DWORD dwSpaceIn, const DWORD dwChannel)
{
	DWORD dwSpace = dwSpaceIn;

	if(dwSpace == 2)
		dwSpace = 0;//ZO[h͒nfWƓ`lg

	// gp\ȃ`lԂ
	if(dwSpace == 0 && (dwChannel > (62-13)))return NULL;//nfW
	if(dwSpace == 1 && (dwChannel > (63-13+12)))return NULL;//nfW /w CATVgϊpXX[
	if(this->EnableDigiRadio)
	{
		if(dwSpace == 3)
		{
			if(dwChannel > 7)return NULL;
			dwSpace--;
		}
		if(dwSpace > 3)return NULL;
	}else{
		if(dwSpace > 2)return NULL;
	}


	static const TCHAR aszChannelName[3][80][12] = 
	{
	{
		TEXT("13ch"), TEXT("14ch"), TEXT("15ch"), TEXT("16ch"), TEXT("17ch"), TEXT("18ch"), TEXT("19ch"),
		TEXT("20ch"), TEXT("21ch"), TEXT("22ch"), TEXT("23ch"), TEXT("24ch"), TEXT("25ch"), TEXT("26ch"), TEXT("27ch"), TEXT("28ch"), TEXT("29ch"),
		TEXT("30ch"), TEXT("31ch"), TEXT("32ch"), TEXT("33ch"), TEXT("34ch"), TEXT("35ch"), TEXT("36ch"), TEXT("37ch"), TEXT("38ch"), TEXT("39ch"), 
		TEXT("40ch"), TEXT("41ch"), TEXT("42ch"), TEXT("43ch"), TEXT("44ch"), TEXT("45ch"), TEXT("46ch"), TEXT("47ch"), TEXT("48ch"), TEXT("49ch"), 
		TEXT("50ch"), TEXT("51ch"), TEXT("52ch"), TEXT("53ch"), TEXT("54ch"), TEXT("55ch"), TEXT("56ch"), TEXT("57ch"), TEXT("58ch"), TEXT("59ch"), 
		TEXT("60ch"), TEXT("61ch"), TEXT("62ch")
	},{
		TEXT("C13ch"), TEXT("C14ch"), TEXT("C15ch"), TEXT("C16ch"), TEXT("C17ch"), TEXT("C18ch"), TEXT("C19ch"),
		TEXT("C20ch"), TEXT("C21ch"), TEXT("C22ch"), TEXT("C23ch"), TEXT("C24ch"), TEXT("C25ch"), TEXT("C26ch"), TEXT("C27ch"), TEXT("C28ch"), TEXT("C29ch"),
		TEXT("C30ch"), TEXT("C31ch"), TEXT("C32ch"), TEXT("C33ch"), TEXT("C34ch"), TEXT("C35ch"), TEXT("C36ch"), TEXT("C37ch"), TEXT("C38ch"), TEXT("C39ch"), 
		TEXT("C40ch"), TEXT("C41ch"), TEXT("C42ch"), TEXT("C43ch"), TEXT("C44ch"), TEXT("C45ch"), TEXT("C46ch"), TEXT("C47ch"), TEXT("C48ch"), TEXT("C49ch"), 
		TEXT("C50ch"), TEXT("C51ch"), TEXT("C52ch"), TEXT("C53ch"), TEXT("C54ch"), TEXT("C55ch"), TEXT("C56ch"), TEXT("C57ch"), TEXT("C58ch"), TEXT("C59ch"), 
		TEXT("C60ch"), TEXT("C61ch"), TEXT("C62ch"), TEXT("C63ch"),
		TEXT("1ch"), TEXT("2ch"), TEXT("3ch"), TEXT("4ch"), TEXT("5ch"), TEXT("6ch"), TEXT("7ch"), TEXT("8ch"), TEXT("9ch"), TEXT("10ch"), TEXT("11ch"), TEXT("12ch")
	},{
		TEXT("DRadio91ch"), TEXT("DRadio92ch"), TEXT("DRadio93ch"), TEXT("DRadio94ch"), 
		TEXT("DRadio95ch"), TEXT("DRadio96ch"), TEXT("DRadio97ch"), TEXT("DRadio98ch"), 
	}
	};

	return aszChannelName[dwSpace][dwChannel];
}

const BOOL cDY_UD200::SetChannel(const DWORD dwSpace, const DWORD dwChannel) 
{
	TCHAR szDbg[96];
	DWORD freq;
	if(this->dwCurChannel == dwChannel && this->dwCurSpace == dwSpace) return TRUE;
	if(!this->EnumChannelName(dwSpace, dwChannel)) return FALSE;

	_stprintf_s(szDbg, _T("SetChannel() Space: %s Channel: %s\n"),
		this->EnumTuningSpace(dwSpace), this->EnumChannelName(dwSpace, dwChannel));
	OutputDebugDYUD200(szDbg);

	if(!this->StopTSStreaming()) return FALSE;

	this->dwCurSpace   = dwSpace;
	this->dwCurChannel = dwChannel;

	freq = this->TranslateChannelToFreq(dwSpace, dwChannel);

	return this->SetFrequency(freq);
}

const DWORD cDY_UD200::GetCurSpace(void)
{
	return this->dwCurSpace;
}

const DWORD cDY_UD200::GetCurChannel(void)
{
	return this->dwCurChannel;
}

/*
B-CASRg[R}h\
    0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
C: 1F F0 F0 0E 02 00 31 00 09 00 00 05 90 30 00 00
            Payload size(p2+5) cyclicnumber 0x00-0x40
               *******?SCReaderCommand?
                           Payloadsize2(p3+4)
                                    Payloadsize3(B-CAS command size)
   00 A5
      xor parity [cyclicnumber - payload3]
*/
BOOL cDY_UD200::SendToBCASAndGetResponse(const BYTE* cmd, BYTE cmdsize, BYTE* response, DWORD resmax, DWORD* ressize)
{
	OutputDebugDYUD200(_T("SendToBCASAndGetResponse() send command to B-CAS\n"));

	if(cmdsize>115)
	{
		OutputDebugDYUD200(_T("SendToBCASAndGetResponse() Illegal command size.\n"));
		return FALSE;
	}
	UCHAR szCmd[128] = {0x1f, 0xf0, 0xf0, 0x00, 0x02, 0x00, 0x31, 0x00,
						0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	UCHAR szRes[128];
	TCHAR szDbg[128];
	BYTE xor;
	int i, j;
	BOOL bResult;

	szCmd[3] = cmdsize +5+4;
	szCmd[8] = cmdsize   +4;
	szCmd[11]= cmdsize;
	memcpy(szCmd+12, cmd, cmdsize);

	j=0;
	do
	{
		xor = 0;
		szCmd[10] = this->uBCAScycle;
		this->uBCAScycle ^= 0x40;
		for(i=10; i<10+cmdsize+2; i++)
		{
			xor ^= szCmd[i];
		}
		szCmd[12+cmdsize] = xor;

		bResult = this->SendCommandAndRecvResponse(szCmd, 12+cmdsize+1, szRes, 128);
		if(bResult)
		{
			if(szRes[0] != 0 || szRes[1] < 6)
			{
				_stprintf_s(szDbg, _T("SendToBCASAndGetResponse() Illegal response. result: 0x%02x\n"), szRes[0]);
				OutputDebugDYUD200(szDbg);
			}else{
				break;
			}
		}

		OutputDebugDYUD200(_T("SendToBCASAndGetResponse() SendCommandAndRecvResponse() returned FALSE. Retry...\n"));
	}while(j++<(int)this->dwBCASRetryCount);

	if(!bResult)
	{
		OutputDebugDYUD200(_T("SendToBCASAndGetResponse() SendCommandAndRecvResponse() returned FALSE. WinUSB internal error?\n"));
		MessageBox(NULL, _T("B-CASJ[hւ̃ANZXɎs܂B\nDY-UD200ZbgĉB"), _T("BonDriver_dyud.dll"), MB_OK|MB_ICONERROR);
		return FALSE;
	}
		
	if(szRes[6] > resmax)
	{
		_stprintf_s(szDbg, _T("SendToBCASAndGetResponse() Response is larger than recv buffer. response size: %d\n"), szRes[6]);
		OutputDebugDYUD200(szDbg);
		return FALSE;
	}
	memcpy(response, szRes+7, szRes[6]);
	*ressize = szRes[6];

	return TRUE;
}

BOOL cDY_UD200::GetRemocon(BYTE* szRes ,BYTE ressize)
{
	UCHAR szCmd[8] = {0x1f, 0xf0, 0xa0, 0x04, 0x00, 0x00, 0x00, 0x00};
	TCHAR szDbg[128];

	if(!this->EnableRemocon)
	{
		return FALSE;
	}

	OutputDebugDYUD200(_T("GetRemocon()... \n"));

	if(!this->SendCommandAndRecvResponse(szCmd, 8, szRes, ressize))
	{
		OutputDebugDYUD200(_T("GetRemocon() internal error.\n"));
		return FALSE;
	}

	if(szRes[0])
	{
		OutputDebugDYUD200(_T("GetRemocon() OK. No input from remocon.\n"));
		return FALSE;
	}

	_stprintf_s(szDbg, _T("GetRemocon() result: 0x%04x\n"), *(WORD*)(szRes+4));
	OutputDebugDYUD200(szDbg);

	return TRUE;
}

DWORD cDY_UD200::TranslateChannelToFreq(DWORD dwSpace, DWORD dwChannel)
{
	DWORD freq;

	if(dwSpace == 2)
		dwSpace = 0;//ZO[h͒nfWƓ`l

	//iniŏ㏑Ă炻Ԃ
	if(this->dwAryOverrideFreq[dwSpace][dwChannel])
		return this->dwAryOverrideFreq[dwSpace][dwChannel];

	if(dwSpace == 0)
	{
		//nfW
		freq = 473143UL + 6000L * dwChannel;
	}else if(dwSpace == 1){
		//nfW /w CATVgϊpXX[
		if(dwChannel <= 21-13)//VHF Mid
			freq = 111143UL + 6000L * dwChannel;
		else if(dwChannel == 22 - 13)
			freq = 167143UL;
		else if(dwChannel == 23 - 13)//VHF SHB
			freq = 225143UL;
		else if(dwChannel <= 27 - 13)
			freq = 233143UL + 6000L * (dwChannel+13-24);
		else if(dwChannel <= 63 - 13)//VHF SHB + UHF
			freq = 255143UL + 6000L * (dwChannel+13-28);
		else if(dwChannel <= 3 + 63 - 13)//VHF Low
			freq = 93143UL + 6000L * (dwChannel+13-64);
		else if(dwChannel <= 7 + 63 - 13)//VHF Hi
			freq = 173143UL + 6000L * (dwChannel+13-67);
		else
			freq = 195143UL + 6000L * (dwChannel+13-71);
	}else{
		//fW^WIMł邩Ȃ

		// 91 92 93 94 95 96 97 98
		//|ii|ii|ii|ii|ii|ii|ii|ii|
		//             Sg190.214286MHz,ZOgԂ3/7MHz
		int i=dwChannel;

		i-=4;
		i*=3000;
		i/=7;
		freq = 190214+i;
	}
	return freq;
}

BOOL cDY_UD200::Initialize_Device(void)
{
	OutputDebugDYUD200(_T("Initialize_Device()\n"));

	if(!this->usbBackend->Open(GUID_DEVINTERFACE_USBDYUD200, VID_DYUD200, PID_DYUD200))
	{
		OutputDebugDYUD200(_T("Initialize_Device() Error. Can't open Device.\n"));
		return FALSE;
	}

	return TRUE;
}

DWORD WINAPI cDY_UD200::RecvRemoconThread(LPVOID pParam)
{
	UCHAR pByte[6];
	UCHAR Keycode, Modifier;
	cDY_UD200 *pThis = (cDY_UD200 *)pParam;
	while(pThis->bLoopThread)
	{
		Sleep(200);
		pThis->GetRemocon(pByte, 6);

		if(pByte[0] != 0)
			continue;

		switch(*(WORD*)(pByte+4))
		{
		case 0x6798://ʕ\
			Keycode =VK_F13 ;Modifier = MK_SHIFT;
			break;
		case 0x6699://
			Keycode =VK_F15 ;Modifier = MK_SHIFT;
			break;
		case 0x6996://
			Keycode =VK_F17 ;Modifier = MK_SHIFT;
			break;
		case 0x659a://1
			Keycode =VK_F17 ;Modifier = MK_SHIFT;
			break;
		case 0x649b://2
			Keycode =VK_F18 ;Modifier = MK_SHIFT;
			break;
		case 0x639c://3
			Keycode =VK_F19 ;Modifier = MK_SHIFT;
			break;
		case 0x619e://4
			Keycode =VK_F20 ;Modifier = MK_SHIFT;
			break;
		case 0x609f://5
			Keycode =VK_F21 ;Modifier = MK_SHIFT;
			break;
		case 0x5fa0://6
			Keycode =VK_F22 ;Modifier = MK_SHIFT;
			break;
		case 0x5da2://7
			Keycode =VK_F23 ;Modifier = MK_SHIFT;
			break;
		case 0x5ca3://8
			Keycode =VK_F24 ;Modifier = MK_SHIFT;
			break;
		case 0x5ba4://9
			Keycode =VK_F13 ;Modifier = MK_CONTROL;
			break;
		case 0x59a6://10/0
			Keycode =VK_F16 ;Modifier = MK_SHIFT;
			break;
		case 0x58a7://11
			Keycode =VK_F14 ;Modifier = MK_CONTROL;
			break;
		case 0x57a8://12
			Keycode =VK_F15 ;Modifier = MK_CONTROL;
			break;
		case 0x4cb3://j[
			Keycode =VK_F16 ;Modifier = MK_CONTROL;
			break;
		case 0x6897://S
			Keycode =VK_F17 ;Modifier = MK_CONTROL;
			break;
		case 0x6d92://d
			Keycode =VK_F14 ;Modifier = MK_SHIFT;
			break;
		case 0x6b94://ؑ
			Keycode =VK_F19 ;Modifier = MK_CONTROL;
			break;
		case 0x53ac://ԑg\
			Keycode =VK_F20 ;Modifier = MK_CONTROL;
			break;
		case 0x4bb4://߂
			Keycode =VK_F21 ;Modifier = MK_CONTROL;
			break;
		case 0x4eb1://^
			Keycode =VK_F22 ;Modifier = MK_CONTROL;
			break;
		case 0x55aa://^CVtg;
			Keycode =VK_F23 ;Modifier = MK_CONTROL;
			break;
		case 0x4ab5://~
			Keycode =VK_F24 ;Modifier = MK_CONTROL;
			break;
		case 0x49b6://Đ
			Keycode =VK_F13 ;Modifier = MK_CONTROL | MK_SHIFT;
			break;
		case 0x48b7://ꎞ~
			Keycode =VK_F14 ;Modifier = MK_CONTROL | MK_SHIFT;
			break;
		case 0x46b9://߂
			Keycode =VK_F15 ;Modifier = MK_CONTROL | MK_SHIFT;
			break;
		case 0x45ba://Wv߂
			Keycode =VK_F16 ;Modifier = MK_CONTROL | MK_SHIFT;
			break;
		case 0x44bb://Wvi
			Keycode =VK_F17 ;Modifier = MK_CONTROL | MK_SHIFT;
			break;
		case 0x43bc://
			Keycode =VK_F18 ;Modifier = MK_CONTROL | MK_SHIFT;
			break;
		case 0x47b8://
			Keycode =VK_F19 ;Modifier = MK_CONTROL | MK_SHIFT;
			break;
		case 0x4fb0://^u;Wv
			Keycode =VK_F20 ;Modifier = MK_CONTROL | MK_SHIFT;
			break;
		case 0x52ad://
			Keycode =VK_LEFT ;Modifier = 0;
			break;
		case 0x54ab://
			Keycode =VK_UP ;Modifier = 0;
			break;
		case 0x50af://
			Keycode =VK_RIGHT ;Modifier = 0;
			break;
		case 0x4db2://
			Keycode =VK_DOWN ;Modifier = 0;
			break;
		case 0x51ae://
			Keycode =VK_RETURN ;Modifier = 0;
			break;
		case 0x629d://+
			Keycode =VK_UP ;Modifier = MK_SHIFT;
			break;
		case 0x5ea1://-
			Keycode =VK_DOWN ;Modifier = MK_SHIFT;
			break;
		case 0x5aa5://`l
			Keycode =VK_UP ;Modifier = MK_CONTROL;
			break;
		case 0x56a9://`l
			Keycode =VK_DOWN ;Modifier = MK_CONTROL;
			break;
/*		case 0x6a95://fؑ
			Keycode =VK_F ;Modifier = MK_CONTROL:
			break;
		case 0x6c93://[hؑ
			break;
		case 0xeb14://3
			break;*/
		default:
			continue;
		}

		if(Modifier & MK_CONTROL)
			keybd_event(VK_CONTROL, 0, 0, 0);
		if(Modifier & MK_SHIFT)
			keybd_event(VK_SHIFT, 0, 0, 0);

		keybd_event(Keycode, 0, KEYEVENTF_EXTENDEDKEY, 0);
		keybd_event(Keycode, 0, KEYEVENTF_EXTENDEDKEY|KEYEVENTF_KEYUP, 0);

		if(Modifier & MK_SHIFT)
			keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
		if(Modifier & MK_CONTROL)
			keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
	}
	return 0;
}

#define TS_PACKET_READ_NUMBER 64
DWORD WINAPI cDY_UD200::RecvTSThread(LPVOID pParam)
{
	cDY_UD200 *pThis = (cDY_UD200 *)pParam;

	TCHAR szDbg[128];
	BOOL bResult;
	CTSPacket Packet;
	DWORD dwDatasize, dwPointer, dw;

	UCHAR szBuf[(TS_PACKET_READ_NUMBER+3)*TS_PACKET_SIZE];

	while(pThis->bLoopThread)
	{
		if(!pThis->IsTunerOpening())
		{
			Sleep(1);
			continue;
		}

		if(!pThis->bTsRunning)
		{
			Sleep(1);
			continue;
		}

		//`[iXe[^XmF
		if(!pThis->bTunerLock)
		{
			OutputDebugDYUD200( _T("RecvTS() Check tuner status... \n"));
			if(pThis->GetLockStatus() > 8)
			{
				OutputDebugDYUD200( _T("RecvTS() Check tuner status OK.\n"));
				pThis->bTunerLock = TRUE;
				
				//pPbgǂݎ̂
				OutputDebugDYUD200( _T("RecvTS() Purge 8192 packets.\n"));
				for(int i=0; i<64; i++)
					pThis->usbBackend->ReadPipe(TS_IN_PIPE, szBuf, 128*TS_PACKET_SIZE, &dwDatasize);
				dwDatasize = 0;
			}
			else
			{
				OutputDebugDYUD200( _T("RecvTS() Check tuner status NG.\n"));
				Sleep(100);
				continue;
			}
		}
		
		//USBXg[ǂݍ
		OutputDebugDYUD200( _T("RecvTS() UUSBBackend_ReadPipe\n"));
		bResult = pThis->usbBackend->ReadPipe(TS_IN_PIPE, szBuf+dwDatasize, TS_PACKET_READ_NUMBER*TS_PACKET_SIZE, &dw);
		dwDatasize += dw;

		//G[
		DWORD dwErrorCode = GetLastError();
		_stprintf_s(szDbg, _T("RecvTS() UUSBBackend_ReadPipe result:%d recvsize:%d GetLastError: 0x%x\n"),
			bResult, dw, dwErrorCode);
		OutputDebugDYUD200(szDbg);
		//G[Ŏʐݒ̏ꍇ
		if(!bResult && !pThis->bForceRetryTs)
		{
			_stprintf_s(szDbg, _T("UUSBBackend_ReadPipe()Ɏs(Error= 0x%08x)܂B\tgċNĉB\npɂɂ̃bZ[Woꍇ́AForceRetryTs1ɐݒ肵Ă݂ĉB"),
			dwErrorCode);
			MessageBox(NULL, szDbg, _T("BonDriver_dyud.dll"), MB_OK|MB_ICONERROR);
			break;
		}

		dwPointer = 0;

		//TSpPbg؂oăobt@Ɋi[
		pThis->LockTs();
		while(dwDatasize-dwPointer > 3*TS_PACKET_SIZE)
		{
			//TSpPbg̓o
			if(!pThis->bTsLock)
			{
				if(szBuf[dwPointer] == 0x47 &&
					szBuf[dwPointer+TS_PACKET_SIZE] == 0x47 &&
					szBuf[dwPointer+TS_PACKET_SIZE*2] == 0x47 &&
					szBuf[dwPointer+TS_PACKET_SIZE*3] == 0x47)
				{
					pThis->bTsLock = true;
				}else{
					dwPointer++;
					continue;
				}
			}
			if(szBuf[dwPointer] != 0x47)
			{
				OutputDebugDYUD200(_T("RecvTS() Lost sync to TS.\n"));
				pThis->bTsLock = false;
				continue;
			}

			Packet.Clear();
			Packet.AddPacket(szBuf+dwPointer);//pPbgobt@؂o

			pThis->cPacketFilter.ParsePacket(Packet);

			do{
				//tB^Oݒ肪s
				if(pThis->PacketFiltering >2)
					break;

				if(pThis->PacketFiltering ==1)//tB^OL
				{
					if(!pThis->cPacketFilter.CheckAllow(Packet))
						break;
				}

				if(pThis->PacketFiltering ==2)//NullpP̂ݐ؂΂
				{
					if(Packet.PID() == 0x1fff)
						break;
				}

				if( (pThis->ringBufferRecv->UsedSize()+1) == pThis->ringBufferRecv->BufferSize())
				{
					OutputDebugDYUD200(_T("RecvTS() TS recv buffer over run.\n"));
				}else{
					*pThis->ringBufferRecv << Packet;
				}
			}while(0);

			dwPointer+=TS_PACKET_SIZE;
		}
		pThis->UnlockTs();

		//]f[^obt@̐擪ɋl߂
		memmove(szBuf, szBuf+dwPointer, dwDatasize-dwPointer);
		dwDatasize-=dwPointer;
	}

	return 0;
}

BOOL cDY_UD200::SendCommandAndRecvResponse(UCHAR cmd[], int cmdsize, UCHAR res[], int ressize)
{
	UCHAR szBuffer[132], szEncrypted[132];
	TCHAR szDbg[256];
	BOOL bResult;
	DWORD ul;
	BIDWORD crc;

	if(!this->usbBackend->IsOpened())
	{
		return FALSE;
	}
	if(cmdsize > 128)
		return FALSE;

	memcpy(szBuffer, cmd, cmdsize);

	crc = CrcCalc.crc(szBuffer, 128);
	*(PDWORD)(szBuffer+128) = crc.GetInvert();

	if(*szBuffer & 0x10)
		this->CmdKeyAESencrypt.ecb_encrypt(szBuffer+2, szEncrypted+2, 128);
	else{
		this->DefaultKeyAESencrypt.ecb_encrypt(szBuffer+2, szEncrypted+2, 128);
		this->CmdKeyAESencrypt.key128(szBuffer+16);
	}
	*(PUSHORT)szEncrypted = *(PUSHORT)szBuffer;
	*(PUSHORT)(szEncrypted+130) = *(PUSHORT)(szBuffer+130);

	OutputDebugDYUD200(_T("SendCommandAndRecvResponse() Send command... \n"));

	this->LockIo();

	bResult = this->usbBackend->WritePipe(COMMAND_OUT_PIPE, szEncrypted, 132, &ul);
	if(!bResult)
	{
		OutputDebugDYUD200(_T("SendCommandAndRecvResponse() NG.\n"));
		this->UnlockIo();
		return FALSE;
	}

	OutputDebugDYUD200(_T("SendCommandAndRecvResponse() OK. Recv response... \n"));
	bResult = pThis->usbBackend->ReadPipe(RESPONSE_IN_PIPE, szEncrypted, 128, &ul);

	this->UnlockIo();

	if(!bResult)
	{
		OutputDebugDYUD200(_T("SendCommandAndRecvResponse() NG.\n"));
		return FALSE;
	}
	OutputDebugDYUD200(_T("SendCommandAndRecvResponse() OK. CRC check... \n"));

	this->DefaultKeyAESdecrypt.ecb_decrypt(szEncrypted, szBuffer, 128);

	crc = CrcCalc.crc(szBuffer, 124);
	if(*(PDWORD)(szBuffer+124) != crc.GetInvert())
	{
		OutputDebugDYUD200(_T("SendCommandAndRecvResponse() NG. Firmware bug? Or USB error?\n"));
		SetLastError(23);
		return FALSE;
	}
	_stprintf_s(szDbg, _T("SendCommandAndRecvResponse() OK. result: 0x%02x\n"), szBuffer[0]);
	OutputDebugDYUD200(szDbg);
	memcpy(res, szBuffer, 128>ressize?ressize:128);

	return TRUE;
}

BOOL cDY_UD200::GetFirmwareVersion(FIRMVERSION* fv)
{
	UCHAR szRes[6];

	if(!this->usbBackend->IsOpened())
	{
		return FALSE;
	}
	
	UCHAR szCmdGetFirmwareVersion[8] = {0x1f, 0xf0, 0x9f, 0x04, 0x00, 0x00, 0x00, 0x00};
	if(!this->SendCommandAndRecvResponse(szCmdGetFirmwareVersion, 8, szRes, 6))
		return FALSE;

	fv->D.major = szRes[2];
	fv->D.minor1 = szRes[3];
	fv->D.minor2 = szRes[4];
	fv->D.minor3 = szRes[5];

	return TRUE;
}

BOOL cDY_UD200::GetSerialnumber(char szSerial[16])
{
	UCHAR szRes[18];
	UCHAR szCmdGetSerial[8] = {0x1f, 0xf0, 0x95, 0x04, 0x00, 0x00, 0x00, 0x00};
	if(!this->SendCommandAndRecvResponse(szCmdGetSerial, 8, szRes, 18))
		return FALSE;

	memcpy(szSerial, szRes+2, 16);
	return TRUE;
}

UCHAR cDY_UD200::GetLockStatus(void)
{
	UCHAR szRes[4];
	UCHAR szCmd[8] = {0x1f, 0xf0, 0xb1, 0x04, 0x26, 0x0a, 0x00, 0x00};
	TCHAR szDbg[64];

	OutputDebugDYUD200(_T("GetLockStatus() Check... \n"));
	if(!this->SendCommandAndRecvResponse(szCmd, 8, szRes, 4))
		return 0;

	if(szRes[0] != 0)
		return 0;

	_stprintf_s(szDbg, _T("GetLockStatus() Check... status%d\n"), szRes[3]);
	OutputDebugDYUD200(szDbg);

	return szRes[3];
}

BOOL cDY_UD200::SetFrequency(DWORD freq)
{
	UCHAR szRes[1];
	UCHAR szCmd[10] = {0x1f, 0xf0, 0xd2, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	TCHAR szDbg[64];

	if(!this->SetSegMode())	return FALSE;
	if(!this->SetTSXorKey())return FALSE;

	BIDWORD ul;
	ul = freq;
	*(DWORD*)(szCmd + 4) = ul.GetInvert();

	_stprintf_s(szDbg, _T("SetFrequency() freq: %dkHz\n"), freq);
	OutputDebugDYUD200(szDbg);

	if(!this->SendCommandAndRecvResponse(szCmd, 8, szRes, 1))
		return FALSE;

	if(*szRes)
		return FALSE;

	cPacketFilter.Clear();


	return this->StartTSStreaming();
}

BOOL cDY_UD200::SetSegMode(DWORD seg)
{
	UCHAR szRes[1];
	UCHAR szCmd[10] = {0x1f, 0xf0, 0xd1, 0x04, 0x00, 0x02, 0x00, 0x00};
	TCHAR szDbg[64];

	BIDWORD ul;
	ul = seg;
	*(DWORD*)(szCmd + 4) = ul.GetInvert();

	_stprintf_s(szDbg, _T("SetSegMode() Mode: %08x\n"), seg);
	OutputDebugDYUD200(szDbg);

	if(!this->SendCommandAndRecvResponse(szCmd, 8, szRes, 1))
		return FALSE;

	if(*szRes)
		return FALSE;

	return TRUE;
}

BOOL cDY_UD200::SetSegMode(void)
{
	if((this->dwCurSpace == 3 && this->EnableDigiRadio == 1) || this->dwCurSpace == 2)
	{
		//ZO[h
		return this->SetSegMode(0x00010000);
	}else{
		//tZO[h
		return this->SetSegMode(0x00020000);
	}
}

BOOL cDY_UD200::SetTSXorKey(void)
{
	UCHAR key[32] = 
	{
		0x93, 0xAD, 0x82, 0xA2, 0x82, 0xBD, 0x82, 0xE7,
		0x82, 0xDC, 0x82, 0xAF, 0x82, 0xC5, 0x82, 0xB2,
		0x82, 0xB4, 0x82, 0xE9, 0x81, 0x49, 0x95, 0x89,
		0x82, 0xAF, 0x82, 0xC5, 0x82, 0xB2, 0x82, 0xB4
	};

	return this->SetTSXorKey(key, 32);
}

BOOL cDY_UD200::SetTSXorKey(UCHAR* key, DWORD keysize)
{
	UCHAR szRes[1];
	UCHAR szCmd[36] = {0x1f, 0xf0, 0x30, 0x20};

	if(keysize > 32) keysize = 32;

	CreateLUT(this->szTSxorLUT , pbDefalutXORkey, 32);
	XORcrypt(this->szTSxorLUT, szCmd+4, key, keysize);
	CreateLUT(this->szTSxorLUT, key, keysize);

	OutputDebugDYUD200(_T("SetTSXorKey()\n"));

	if(!this->SendCommandAndRecvResponse(szCmd, 36, szRes, 1))
		return FALSE;
	return TRUE;
}

BOOL cDY_UD200::StopTSStreaming(void)
{
	UCHAR szRes[1];
	UCHAR szCmd[8] = {0x1f, 0xf0, 0xb5, 0x04, 0x00, 0x00, 0x00, 0x00};

	this->bTsRunning = FALSE;

	OutputDebugDYUD200(_T("StopTSStreaming()\n"));
	if(!this->SendCommandAndRecvResponse(szCmd, 8, szRes, 1))
		return FALSE;

	return TRUE;
}

BOOL cDY_UD200::StartTSStreaming(void)
{
	UCHAR szRes[1];
	UCHAR szCmd[8] = {0x1f, 0xf0, 0xb4, 0x04, 0x00, 0x00, 0x00, 0x00};

	this->bTunerLock = FALSE;
	OutputDebugDYUD200(_T("StartTSStreaming()\n"));
	if(!this->SendCommandAndRecvResponse(szCmd, 8, szRes, 1))
		return FALSE;
	
	this->bTsRunning = TRUE;
	return TRUE;
}

BOOL cDY_UD200::LoadConfiguration(void)
{
	TCHAR szPath[1024];
	int Space, Channel;

	GetModuleFileName(hModuleThis, szPath ,1024);

	_stprintf_s(szPath , _T("%s%s") , szPath , _T(".ini"));

	//`lg̏㏑
	Space=0;
	while(this->EnumTuningSpace(Space))
	{
		Channel=0;
		while(this->EnumChannelName(Space, Channel))
		{
			this->dwAryOverrideFreq[Space][Channel] = GetPrivateProfileInt(this->EnumChannelName(Space, Channel), _T("OverrideFreq"), 0, szPath);
			Channel++;
		}
		Space++;
	}

	//Mobt@TCY
	this->ringBufferRecv = new CRingBuffer<CTSPacket>(GetPrivateProfileInt(_T("BonDriver_dyud"), _T("TsRecvBufferSize"), DEFAULT_TS_BUFFER_SIZE, szPath));
	//BJXgC
	this->dwBCASRetryCount = GetPrivateProfileInt(_T("BonDriver_dyud"), _T("BCASRetryCount"), DEFAULT_BCAS_RETRY_COUNT, szPath);
	//TSMɎsĂabortȂ
	this->bForceRetryTs = GetPrivateProfileInt(_T("BonDriver_dyud"), _T("ForceRetryTs"), DEFAULT_FORCE_RETRY_TS, szPath);
	//pPbgtB^O
	this->PacketFiltering = GetPrivateProfileInt(_T("BonDriver_dyud"), _T("PacketFiltering"), DEFAULT_PACKET_FILTERING, szPath);
	//Xbh̗D揇
	this->threadPriority = GetPrivateProfileInt(_T("BonDriver_dyud"), _T("ThreadPriority"), DEFAULT_THREAD_PRIORITY, szPath);
	//xorÍtO
	this->xorCryptedFlag = GetPrivateProfileInt(_T("BonDriver_dyud"), _T("EnableXor"),DEFAULT_ENABLE_XOR, szPath);
	//fW^WILtO
	this->EnableDigiRadio = GetPrivateProfileInt(_T("BonDriver_dyud"), _T("EnableDigitalRadio"),DEFAULT_ENABLE_DIGIRADIO, szPath);
	//RLtO
	this->EnableRemocon = GetPrivateProfileInt(_T("BonDriver_dyud"), _T("EnableRemocon"),DEFAULT_ENABLE_REMOCON, szPath);
	//AeixLtO
	this->EnableAntLv = GetPrivateProfileInt(_T("BonDriver_dyud"), _T("EnableAntLv"),DEFAULT_ENABLE_ANTLV, szPath);
	//B25fR[hLtO
	this->enableB25Decode = GetPrivateProfileInt(_T("BonDriver_dyud"), _T("EnableB25Decode"),DEFAULT_ENABLE_B25DECODE, szPath);
	//SSE2LtO
	this->enableSSE2 = GetPrivateProfileInt(_T("BonDriver_dyud"), _T("EnableSSE2"),DEFAULT_ENABLE_SSE2, szPath);
	this->tsDescrambler.SetSSE2(this->enableSSE2!=0);
	//t@[EFÃo[W`FbNLtO
	this->enableFirmAlert = GetPrivateProfileInt(_T("BonDriver_dyud"), _T("EnableFirmwareAlert"),DEFAULT_ENABLE_FIRMALERT, szPath);
	//USBobNGhI
	this->usbBackendType = GetPrivateProfileInt(_T("BonDriver_dyud"), _T("UsbBackendType"),DEFAULT_BACKEND, szPath);

	//mF_CAO\
	if(GetPrivateProfileInt(_T("BonDriver_dyud"), _T("InformationDialog"), 0, szPath))
	{
		TCHAR szMessage[1024];
		_stprintf_s(szMessage, _T("%s ݒǂݍ݂܂B\nTSMobt@TCY\t\t: %d\nB-CASgC\t\t\t: %d\n")\
				_T("TSrecvsĂĎs\t: %s\npPbgtB^O\t: %s\nTSMXbh̗D揇\t\t: %d\n")\
				_T("xorÍ\t\t\t\t: %s\nfW^WIMeXg\t\t: %s\nRL\t\t\t: %s\nAeix擾\t\t\t: %s\n")\
				_T("B25̃fR[h\t\t\t: %s\nSSE2L\t\t\t\t: %s\nt@[EFAVer`FbN\t\t: %s\nUSBobNGh\t\t\t: %s\n"),
				szPath, this->ringBufferRecv->BufferSize(), this->dwBCASRetryCount,
				this->bForceRetryTs?_T("͂"):_T(""), 
				(this->PacketFiltering==2)?_T("nullpPbĝ"):((this->PacketFiltering==1)?_T("͂"):_T("")),
				this->threadPriority, this->xorCryptedFlag?_T("͂"):_T(""), this->EnableDigiRadio?_T("͂"):_T(""),
				this->EnableRemocon?_T("͂"):_T(""), this->EnableAntLv?_T("͂"):_T(""), this->enableB25Decode?_T("͂"):_T(""),
				this->enableSSE2?_T("͂"):_T(""), this->enableFirmAlert?_T("͂"):_T(""), this->usbBackendType?_T("libusb"):_T("WinUsb"));
		Space=Channel=0;
		while(this->EnumTuningSpace(Space))
		{
			while(this->EnumChannelName(Space, Channel))
			{
				if(this->dwAryOverrideFreq[Space][Channel])
					_stprintf_s(szMessage, _T("%s%s: %d kHz\n"),
						szMessage, this->EnumChannelName(Space, Channel),this->dwAryOverrideFreq[Space][Channel]);
				Channel++;
			}
			Space++;
		}
		_stprintf_s(szMessage, _T("%s̃_CAO\Ȃ悤ɂ邽߂ɂ́Aݒt@CInformationDialog0ɂĉB"),
				szMessage);
		MessageBox(NULL, szMessage, _T(" - BonDriver_dyud.dll"), MB_OK|MB_ICONINFORMATION);
	}

	return TRUE;
}

void cDY_UD200::LockTs(void)
{
//	EnterCriticalSection(&this->TsCriticalSection);
}

void cDY_UD200::UnlockTs(void)
{
//	LeaveCriticalSection(&this->TsCriticalSection);
}

void cDY_UD200::LockIo(void)
{
	EnterCriticalSection(&this->IoCriticalSection);
}

void cDY_UD200::UnlockIo(void)
{
	LeaveCriticalSection(&this->IoCriticalSection);
}


cDY_UD200::cDY_UD200()
{
	this->LoadConfiguration();

	this->DefaultKeyAESdecrypt.key256(pbDefaultKey);
	this->DefaultKeyAESencrypt.key256(pbDefaultKey);
	this->CmdKeyAESencrypt.key128(pbDefaultKey);

	this->hRecvTSThread = NULL;
	this->hRecvRemoconThread = NULL;
	this->bTsLock=FALSE;
	this->bTunerLock=FALSE;
	this->bTsRunning = FALSE;

	this->dwLifecounter = 1;

	InitializeCriticalSectionAndSpinCount(&this->TsCriticalSection, 4000);
	InitializeCriticalSection(&this->IoCriticalSection);

	this->tsDescrambler.SetTunerInterface(this);
	this->tsDescrambler.SetPacketFilterInterface(&this->cPacketFilter);

	if(this->usbBackendType == 0)
		this->usbBackend = new CUUSBB_WinUsb;
	else
		this->usbBackend = new CUUSBB_libusb;

#ifdef DEBUG_LOGGING
	hDebuggingLog = CreateFile(_T("BonDrive_dyud.log") ,GENERIC_WRITE ,0 ,NULL ,CREATE_ALWAYS ,FILE_ATTRIBUTE_NORMAL ,NULL);
	OutputDebugDYUD200(_T("cDY_UD200()\n"));
#endif
}

cDY_UD200::~cDY_UD200()
{
#ifdef DEBUG_LOGGING
	OutputDebugDYUD200(_T("~cDY_UD200()\n"));
	CloseHandle(hDebuggingLog);
#endif
	if(this->dwLifecounter)
		return;

	this->CloseTuner();

	this->dwLifecounter=0;
/*
	if(this->pRecvPackets)
		delete[] this->pRecvPackets;
*/
	delete this->ringBufferRecv;

	DeleteCriticalSection(&this->TsCriticalSection);
	DeleteCriticalSection(&this->IoCriticalSection);
}

extern "C" DECLSPEC IBonDriver * CreateBonDriver()
{
	if(cDY_UD200::pThis)
	{
		cDY_UD200::pThis->dwLifecounter++;
		return cDY_UD200::pThis;
	}else{
		cDY_UD200::pThis = new cDY_UD200;
		return ((IBonDriver *) cDY_UD200::pThis);
	}
}
