#pragma once

#include "IDyud200.h"
#include "Multi2Decoder.h"
#include "TSPacket.h"
#include "TSFilter.h"

class CTSDescrambler
{
public:
	CTSDescrambler();
	CTSDescrambler(bool flagSSE2);

	void SetTunerInterface(IDY_UD200* dy_ud200);
	void SetPacketFilterInterface(CTSPacketFilter* filter);

	void InitializeSystemKey(const BYTE systemKey[32], const BYTE initialCbc[8]);
	bool ParsePacket(CTSPacket& packet);

	void SetSSE2(bool flagSSE2);

private:
	IDY_UD200* pTuner;
	CTSPacketFilter* pFilter;

	CMulti2Decoder decoder;
	CMulti2Decoder::DecodeFunc DecodeFuncPtr;

	CTSPacketSectionAccumulator accECM;

	BYTE oldECM[256];
};
