#pragma once

#pragma warning(push)
#pragma warning(disable: 4995)

#include <vector>
#include <list>
#include <map>

#pragma warning(pop)

#include <boost/pool/pool.hpp>


#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef WORD
typedef unsigned short WORD;
#endif

#define TS_PACKET_SIZE 188

/*
enum TSPARSER_ERROR_CODE
{
	TSP_ERROR_SYNCBYTE_NOTFOUND=0x20000000,
	TSP_ERROR_ERRPRBIT,
};
*/


class CTSPacket
{
protected:
	BYTE pPacket[TS_PACKET_SIZE];
	bool bEmpty;

public:
	//TSwb_
	BYTE LockByte(void);
	BYTE ErrorBit(void);
	BYTE PayloadUnitStart(void);
	BYTE Priority(void);
	WORD PID(void);
	BYTE PayloadScrambleControl(void);
	BYTE AdaptationFieldControl(void);
	BYTE CyclicNumber(void);

	//A_ve[VtB[h
	BYTE AFieldSize(void);
	BYTE AFieldSerial(void);
	BYTE AFieldRandom(void);
	BYTE AFieldESPriority(void);
	BYTE AFieldInPCR(void);
	BYTE AFieldInOPCR(void);
	BYTE AFieldSpriging(void);
	BYTE AFieldTPrivateData(void);
	BYTE AFieldExtend(void);

	//yC[h
	void GetPayload(BYTE* pPayload[], BYTE* pSize);

	//̑
	bool AddPacket(BYTE pPacket[TS_PACKET_SIZE]);
	bool AddPacket(BYTE* pPacket, BYTE size);
	BYTE* GetPacket(void){return this->pPacket;}
	void Clear(void);

	bool IsEmpty(void){return this->bEmpty;}

	CTSPacket();
	CTSPacket(BYTE[TS_PACKET_SIZE]);

	//boost::pool
	static void* operator new (size_t const size);
	static void operator delete (void *p, size_t size);
};

static boost::pool<> CTSPacket_pool(sizeof(CTSPacket));


class CTSPacketSectionAccumulator
{
protected:
	WORD pid;

	BYTE Buffer[4232];//ZNV̍őTCY4096A傫184̔{
	unsigned int nAccumulatedBuffer;//ZNVf[^̒~σoCg
	unsigned int nSectionSize;//ZNṼTCYA0Ȃ擪rbgĂȂpP͖
	BYTE CyclicNumber;//TSpPCNAĂobt@j

public:
	void SetPID(WORD p){this->pid = p;}
	WORD GetPID(void){return this->pid;}

	bool GetSection(BYTE* pSection[], unsigned int* size);
	unsigned int GetSectionSize(void){return this->nSectionSize;}

	bool ParsePacket(CTSPacket& packet);
	bool IsAccumulated(void){return nAccumulatedBuffer >= nSectionSize;}
	void Clear(void){this->nAccumulatedBuffer = 0;}

	CTSPacketSectionAccumulator::CTSPacketSectionAccumulator():nAccumulatedBuffer(0),nSectionSize(-1){}

	//boost::pool
	static void* operator new (size_t const size);
	static void operator delete (void *p, size_t size);
};

static boost::pool<> CTSPacketSectionAccumulator_pool(sizeof(CTSPacketSectionAccumulator));

//GfBAϊoDWORD
class BIDWORD
{
public:
	BIDWORD(){};
	BIDWORD(DWORD);
	void operator=(DWORD);
	DWORD GetInvert(void);
private:
	DWORD ul;
};

//ZNVCRCvZp
DWORD CalcTsCrc32(const BYTE *pData, DWORD DataSize);
DWORD CalcTsCrc32Acc(const BYTE *pData, DWORD DataSize, DWORD dwCurCrc);
