#include "stdafx.h"

#include "dy-ud200-tools.h"

#ifdef DEBUG_LOGGING
void OutputDebugStringToFile(LPCTSTR str)
{
	DWORD dw;
	TCHAR szStr[128];

	_stprintf_s(szStr, _T("%010d: "), timeGetTime());
	WriteFile(hDebuggingLog, szStr, _tcslen(szStr)*sizeof(TCHAR), &dw, 0);
	WriteFile(hDebuggingLog, str, _tcslen(str)*sizeof(TCHAR), &dw, 0);
}
#endif


void charToTchar(TCHAR* tc, size_t size, char* ch)
{
	int i,cpsize;

	cpsize = strlen(ch)+1>size?size:strlen(ch)+1;

	if(sizeof(TCHAR) == 1)
	{
		memcpy(tc, ch, cpsize);
		return;
	}

	memset(tc, 0, size);
	for(i=0; i<cpsize; i++)
	{
		tc[i] = ch[i];
	}
}

void CreateLUT(UCHAR LUT[514],const UCHAR* key, DWORD keysize)
{
	DWORD i;
	UCHAR keyoffset,shuffleindex,exbuf;
	LUT[512]=1;LUT[513]=0;

	for(i=0; i<256; i++)LUT[i]=(UCHAR)i;//={00,01,02,03,04, ... ,255};

	keyoffset=shuffleindex=0;

	for(i=0; i<256; i++)
	{
		exbuf = LUT[i];
		shuffleindex += key[keyoffset]+LUT[i];
		LUT[i] = LUT[shuffleindex];
		LUT[shuffleindex] = exbuf;
		if(++keyoffset == keysize) keyoffset=0;
	}
	memcpy(LUT+256, LUT, 256);
}

void XORcrypt(UCHAR *ptn, UCHAR *d, UCHAR *s, DWORD c)
{
	UCHAR n, t, p1 = ptn[512], p2 = ptn[513];
	for (n = 0; n < c; n++) {
		p2 += t = ptn[p1++];
		t += ptn[p2];
		*(d++) = *(s++) ^ ptn[t];
	}
} 

