#pragma once

#ifdef BONDRIVER_DYUD_MAIN
#define DYUD_EXPORT
#else
#define DYUD_EXPORT extern
#endif

//DY-UD200 /w WinUSB̌ɎgGUID
const GUID GUID_DEVINTERFACE_USBDYUD200={0x57fe8cc2, 0x6246, 0x4ed6, {0xba, 0x64, 0xac, 0x45, 0x75, 0xf0, 0x12, 0x70}};
//{57fe8cc2-6246-4ed6-ba64-ac4575f01270}
//DY-UD200 /w libusb̌ɎgVIDPID
const WORD VID_DYUD200= 0x1c11, PID_DYUD200= 0x1004;

//pCvID
const BYTE COMMAND_OUT_PIPE=0x02;
const BYTE RESPONSE_IN_PIPE=0x84;
const BYTE TS_IN_PIPE=0x86;

//Logt@CɎcH
#ifdef DEBUG_LOGGING

	#define OutputDebugDYUD200(x) OutputDebugStringToFile(x)
	DYUD_EXPORT HANDLE hDebuggingLog;

#else

	//[hłȂĂfobOrhłOutputDebugStringɏo͂
	#ifdef _DEBUG
	#define OutputDebugDYUD200(x) OutputDebugString(x)
	#else
	//[ǂłȂ[XrĥĂ
	#define OutputDebugDYUD200(x) 1
	#endif

#endif

//GetTsStream̒iKTSlogɎcH
#ifdef DEBUG_TS_DUMP
DYUD_EXPORT HANDLE hTSLogFile;
#endif

#pragma pack(1)
union FIRMVERSION
{
	struct
	{
		UCHAR minor3;
		UCHAR minor2;
		UCHAR minor1;
		UCHAR major;
	} D;
	DWORD ul;
};
#pragma pack()

#ifdef _DEBUG
const unsigned char testdata_encrypted[256] = // default key test data 
{0x36,0x8a,0xca,0x88,0xeb,0x54,0x1c,0x32,0xc9,0x54,0x9c,0x3a,0x6e,0xf3,0xfd,0xc2
,0x9b,0x56,0x38,0xf4,0x51,0x24,0xd7,0xd0,0x79,0x15,0x32,0xf5,0x52,0x39,0x14,0x14
,0xed,0x34,0x08,0xe4,0x6b,0xe8,0xdc,0xa4,0x3e,0x8c,0x6a,0xf8,0xe7,0xef,0x5f,0x84
,0x25,0x65,0x2d,0xec,0x7f,0x0d,0xeb,0x40,0x51,0x38,0xd9,0xe1,0x1d,0xfe,0x24,0x17
,0xa4,0x00,0xf0,0x1c,0xf0,0x42,0x89,0xaa,0x9b,0xd1,0x01,0x83,0x81,0x65,0x0d,0x03
,0xcc,0x73,0x7d,0x32,0xcf,0x3b,0x2c,0x9b,0x09,0x73,0xf3,0xba,0x86,0x62,0xdd,0xcb
,0xcc,0x73,0x7d,0x32,0xcf,0x3b,0x2c,0x9b,0x09,0x73,0xf3,0xba,0x86,0x62,0xdd,0xcb
,0xa8,0xf4,0x2b,0xb4,0x7a,0x40,0x39,0xb5,0x0e,0x77,0x19,0x44,0x87,0x0c,0x8b,0xbe
};

const unsigned char testdata_decrypted[256] =
{ 0x00, 0x1c, 0x23, 0x8d, 0xc0, 0xd0, 0x00, 0x00, 0x00, 0x00, 0x01, 0x70, 0x6b, 0xa3, 0x00, 0x07
, 0xde, 0xd1, 0x00, 0x0a, 0xce, 0xd4, 0x60, 0x00, 0x00, 0x13, 0x00, 0x0a, 0xce, 0xd4, 0xb8, 0x8c
, 0x69, 0x47, 0x81, 0x3c, 0x4c, 0x00, 0x3b, 0x0f, 0xb2, 0xca, 0x2b, 0xef, 0xd6, 0x21, 0x43, 0x95
, 0x52, 0x06, 0x3f, 0xe3, 0xa5, 0x73, 0x48, 0xdb, 0x49, 0x1d, 0x9e, 0xce, 0x7b, 0x18, 0xaf, 0xde
, 0xf8, 0x60, 0x77, 0x15, 0xbb, 0xf8, 0xdc, 0x95, 0x57, 0xf2, 0x95, 0x76, 0xc1, 0x68, 0x57, 0x73
, 0xf0, 0xca, 0x06, 0xff, 0x83, 0x00, 0x8f, 0xc1, 0x1f, 0xf0, 0x97, 0x9a, 0x05, 0x86, 0x5d, 0xab
, 0xf0, 0xca, 0x06, 0xff, 0x83, 0x00, 0x8f, 0xc1, 0x1f, 0xf0, 0x97, 0x9a, 0x05, 0x86, 0x5d, 0xab
, 0xed, 0x29, 0x30, 0x54, 0x65, 0x8b, 0xe7, 0x71, 0x76, 0x54, 0x04, 0xe1, 0xf9, 0xff, 0x12, 0x56
};
#endif

extern void charToTchar(TCHAR* tc, size_t size, char* ch);

extern void CreateLUT(UCHAR* LUT,const UCHAR* key, DWORD keysize);
extern void XORcrypt(UCHAR* LUT, UCHAR* dst, UCHAR* src, DWORD size);

extern void OutputDebugStringToFile(LPCTSTR str);

