#pragma once

#include "Iuusbb.h"

//WinUsb
#include <WinUsb.h>
#include <usb100.h>

typedef BOOL (__stdcall *PWINUSB_INITIALIZE)(HANDLE DeviceHandle, PWINUSB_INTERFACE_HANDLE InterfaceHandle);
typedef BOOL (__stdcall *PWINUSB_FREE)(WINUSB_INTERFACE_HANDLE InterfaceHandle);
typedef BOOL (__stdcall *PWINUSB_QUERYINTERFACESETTINGS)(WINUSB_INTERFACE_HANDLE InterfaceHandle,
														 UCHAR AlternateSettingNumber, PUSB_INTERFACE_DESCRIPTOR UsbAltInterfaceDescriptor);
typedef BOOL (__stdcall *PWINUSB_QUERYPIPE)(WINUSB_INTERFACE_HANDLE InterfaceHandle, UCHAR AlternateInterfaceNumber,
											UCHAR PipeIndex, PWINUSB_PIPE_INFORMATION PipeInformation);
typedef BOOL (__stdcall *PWINUSB_SETPIPEPOLICY)(WINUSB_INTERFACE_HANDLE InterfaceHandle, UCHAR PipeID,
												ULONG PolicyType, ULONG ValueLength, PVOID Value);
typedef BOOL (__stdcall *PWINUSB_READPIPE)(WINUSB_INTERFACE_HANDLE InterfaceHandle, UCHAR PipeID, PUCHAR Buffer,
										   ULONG BufferLength, PULONG LengthTransferred, LPOVERLAPPED Overlapped);
typedef BOOL (__stdcall *PWINUSB_WRITEPIPE)(WINUSB_INTERFACE_HANDLE InterfaceHandle, UCHAR PipeID, PUCHAR Buffer,
											ULONG BufferLength, PULONG LengthTransferred, LPOVERLAPPED Overlapped);

//WinUsb---------------------------------------------------------------------------------
class CUUSBB_WinUsb:public IUniversalUSBBackend
{
public:
	//IUniversalUSBBackend methods
	bool Open(const GUID &guid, unsigned short vendorId, unsigned short productId);
	void Close(void);
	bool IsOpened(void);
	
	bool ReadPipe(BYTE pipeId, BYTE* buffer, DWORD bufferSize, DWORD *transferredSize);
	bool WritePipe(BYTE pipeId, BYTE* buffer, DWORD bufferSize, DWORD *transferredSize);

	CUUSBB_WinUsb();
	~CUUSBB_WinUsb();

protected:
	//internal methods
	HANDLE OpenDevice(DWORD index, const GUID &guid);
	BOOL GetDevicePath(const GUID &guid, DWORD dwIndex, PTCHAR DevicePath, size_t bufLen);

	//members
	HANDLE deviceHandle;
	WINUSB_INTERFACE_HANDLE winUSBHandle;

	HMODULE dllHandle;

	PWINUSB_INITIALIZE ptrWinUsb_Initialize;
	PWINUSB_FREE ptrWinUsb_Free;
	PWINUSB_QUERYINTERFACESETTINGS ptrWinUsb_QueryInterfaceSettings;
	PWINUSB_QUERYPIPE ptrWinUsb_QueryPipe;
	PWINUSB_SETPIPEPOLICY ptrWinUsb_SetPipePolicy;
	PWINUSB_READPIPE ptrWinUsb_ReadPipe;
	PWINUSB_WRITEPIPE ptrWinUsb_WritePipe;

	bool loaded;
};
